﻿/*
 * 作成日： 2004/08/05
 *
 * TODO この生成されたファイルのテンプレートを変更するには次を参照。
 * ウィンドウ ＞ 設定 ＞ Java ＞ コード・スタイル ＞ コード・テンプレート
 */
package dictionary;

import java.io.*;


/**
 * @author Administrator Sho Hashimoto
 *
 * TODO この生成された型コメントのテンプレートを変更するには次を参照。
 * ウィンドウ ＞ 設定 ＞ Java ＞ コード・スタイル ＞ コード・テンプレート
 */
public class Word implements Comparable, Serializable{

    
    private Dictionary dictionary; // 辞書
    
    private String jpName; // 単語名(日)
    private String enName; // 単語名(英)
    private String notes; // 単語の意味
    private int date; // 登録日
    
    /*
     * コンストラクタ
     */
    public Word(){
        this.jpName = new String();
        this.enName = new String();
        this.notes = new String();
    }
    
    /*
     * Comparableからオーバーライドした比較メソッド
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    public int compareTo(Object word){        
        return compareStr(this.getJpName(), ((Word)word).getJpName());
    }
    
    /*
     * 文字列を比較してあいうえお順を返す
     */
    private int compareStr(String s1, String s2){
        int len;
        if(s1.length() < s2.length()) len = s1.length(); // 文字数が少ない方に合わせる
        else len = s2.length();
        
        int s1h, s2h;
        for(int i = 0; i < len; i++){
            s1h = s1.substring(i,i+1).toLowerCase().hashCode(); // 1文字のhashCode取得
            s2h = s2.substring(i,i+1).toLowerCase().hashCode();
            if(!(s1h == s2h)) return s1h - s2h; // 同じでなかったら1文字進む
        }
        return s1.length() - s2.length(); // 途中まで全部同じなら、長い方を後にするルール
    }
    
    /*
     * toStringをオーバーライド
     * @see java.lang.Object#toString()
     */
    public String toString(){
        return this.jpName;
    }
    
    /**
     * @return enName
     */
    public String getEnName() {
        return this.enName;
    }
    /**
     * @param enName enName を設定します。
     */
    public void setEnName(String enName) {
        this.enName = enName;
    }
    /**
     * @return jpName
     */
    public String getJpName() {
        return this.jpName;
    }
    /**
     * @param jpName jpName を設定します。
     */
    public void setJpName(String jpName) {
        this.jpName = jpName;
    }
    /**
     * @return notes
     */
    public String getNotes() {
        return this.notes;
    }
    /**
     * @param notes notes を設定します。
     */
    public void setNotes(String notes) {
        this.notes = notes;
    }
}